/**
* @file PIDC_cog.h
* Proportional Integral Derivative Controller
*
* @version @n 1.0
* @date @n Dec 2014
*
* @author @n Kwabena W. Agyeman
*/

#ifndef PIDC_COG_H
#define PIDC_COG_H

#include "propeller.h"

typedef enum
{
    A_B_ENCODER_TYPE,
    DIR_PWM_ENCODER_TYPE
}
PIDCEncoderTypeT;

typedef enum
{
    POSITION_CONTROL,
    VELOCITY_CONTROL
}
PIDCControlTypeT;

typedef enum
{
    A_B_MOTOR_TYPE,
    DIR_PWM_MOTOR_TYPE
}
PIDCMotorTypeT;

typedef struct
{
    PIDCEncoderTypeT encoderType;
    int encoderUpdateRateInClockTicks;
    int ADIREncoderPin;
    int BPWMEncoderPin;

    PIDCControlTypeT controlType;
    int controlUpdateRateInClockTicks;

    PIDCMotorTypeT motorType;
    int motorUpdateRateInClockTicks;
    int ADIRMotorPin;
    int BPWMMotorPin;

    int PGainPower;
    int IGainPower;
    int DGainPower;

    int sampledPositionInEncoderTicks;
    int sampledVelocityInEncoderTicks;

    int targetPositionOrVelocityInEncoderTicks;
}
PIDCMailBoxT;

#endif // PIDC_COG_H
